Package org.eclipse.rdf4j.common.iterator

## Class AbstractCloseableIterator<E>

- java.lang.Object
- - org.eclipse.rdf4j.common.iterator.AbstractCloseableIterator<E>

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`, `Iterator<E>`
  Direct Known Subclasses:
    `LookAheadIterator`

      public abstract class AbstractCloseableIterator<E>
      extends Object
      implements Iterator<E>, Closeable

  Author:
    MJAHale

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractCloseableIterator()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Calls `handleClose()` upon first call and makes sure this method gets called only once.
    `protected void` | `handleAlreadyClosed()` |
    `protected void` | `handleClose()` | Called by `close()` when it is called for the first time.
    `boolean` | `isClosed()` | Checks whether this Iterator has been closed.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, hasNext, next, remove`

- - ### Constructor Detail

    - #### AbstractCloseableIterator

          public AbstractCloseableIterator()

  - ### Method Detail

    - #### isClosed

          public final boolean isClosed()

      Checks whether this Iterator has been closed.
      Returns:
        true if the Iterator has been closed, false otherwise.

    - #### close

          public final void close()
                           throws IOException

      Calls `handleClose()` upon first call and makes sure this method gets called only once.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `Closeable`
      Throws:
        `IOException`

    - #### handleClose

          protected void handleClose()
                              throws IOException

      Called by `close()` when it is called for the first time. This method is only called once on each iteration. By default, this method does nothing.
      Throws:
        `X`
        `IOException`

    - #### handleAlreadyClosed

          protected void handleAlreadyClosed()
                                      throws IOException

      Throws:
        `IOException`